#include <boost/python.hpp>
#include "relicwrapper.h"

using namespace boost::python;

BOOST_PYTHON_MODULE(pyrelic)
{
    class_<Zr>("Zr",init<>())
      .def(init<int>())
      .def("toString",&Zr::toString)
      .def("__str__",&Zr::decimalToString)
      .def("fromString",&Zr::fromString)
      .def("randomize",&Zr::randomize)
      .def("__add__",&Zr::operator+)
      .def("__sub__",&Zr::operator-)
      .def("__mul__",&Zr::operator*)
      .def("__div__",&Zr::operator/)
      .def("__pow__",&Zr::operator^)
      .def("__xor__",&Zr::operator^) //__xor__ = ^ symbol, __pow__ = **; I've never liked this aspect of Python, so why not correct it
      .def("__eq__",&Zr::operator==)
    ;
    class_<G1>("G1",init<>())
      .def(init<bool>())
      .def("toString",&G1::toString)
      .def("__str__",&G1::decimalToString)
      .def("fromString",&G1::fromString)
      .def("randomize",&G1::randomize)
      .def("__mul__",&G1::operator*)
      .def("__div__",&G1::operator/)
      .def("__pow__",&G1::operator^)
      .def("__xor__",&G1::operator^)
      .def("__eq__",&G1::operator==)
    ;
    class_<G2>("G2",init<>())
      .def(init<bool>())
      .def("toString",&G2::toString)
      .def("__str__",&G2::decimalToString)
      .def("fromString",&G2::fromString)
      .def("randomize",&G2::randomize)
      .def("__mul__",&G2::operator*)
      .def("__div__",&G2::operator/)
      .def("__pow__",&G2::operator^)
      .def("__xor__",&G2::operator^)
      .def("__eq__",&G2::operator==)
    ;
    class_<GT>("GT",init<>())
      .def(init<bool>())
      .def("toString",&GT::toString)
      .def("__str__",&GT::decimalToString)
      .def("fromString",&GT::fromString)
      .def("randomize",&GT::randomize)
      .def("__mul__",&GT::operator*)
      .def("__div__",&GT::operator/)
      .def("__pow__",&GT::operator^)
      .def("__xor__",&GT::operator^)
      .def("__eq__",&GT::operator==)
    ;
    class_<Pairing>("Pairing",init<>())
      .def("__call__",&Pairing::operator())
    ;
    def("initPairing", initPairing);
    def("delPairing", delPairing);
}
